--this is KartSoundScapes
freeslot("sfx_ksflap")

local kss = false
local finallapmusic = false
local glidermusic = false
local normalmusic, finallap, normalglider, finalglider

addHook("MapLoad", function(mapid)
    kss = mapheaderinfo[mapid].kartsoundscapes == "true"
    
    if not kss then return end
    
    normalmusic = mapheaderinfo[mapid].normalmusic
    
    finallapmusic = mapheaderinfo[mapid].finallapmusic == "true"
    
    if finallapmusic then
        finallap = mapheaderinfo[mapid].finallap
    end
    
    glidermusic = mapheaderinfo[mapid].glidermusic == "true"
    
    if glidermusic then
        normalglider = mapheaderinfo[mapid].normalglider
        finalglider = mapheaderinfo[mapid].finalglider
    end
end)

-- Yea synching these vars is very important and very worth it, trust me
addHook("NetVars", function(net)
    kss = net($)
    finallapmusic = net($)
    glidermusic = net($)
    normalmusic = net($)
    finallap = net($)
    normalglider = net($)
    finalglider = net($)
end)

addHook("ThinkFrame", function()
    if leveltime < 2 then return end
	if not kss then return end
    local player = consoleplayer -- Too lazy to replace all "player" with "consoleplayer"
    
	if leveltime == 2 then player.flapjingleflag = false end
	player.flapjingle = $ or 0
	local currentmusic, dummy1, dummy2 = S_MusicInfo(player)
	local isPowerMusic = player.kartstuff[k_invincibilitytimer] > 0 or player.kartstuff[k_growshrinktimer] > 0
    
	--print(isPowerMusic)
	--print(player.flapjingle)
	if leveltime < 8*TICRATE then return end
	if player.exiting or (player.pflags & PF_TIMEOVER) then return end
	--print("KSS enabled")
	if finallapmusic then
		player.finallapmusic = player.laps == mapheaderinfo[gamemap].numlaps -1
	end
    
	if glidermusic and player.mo and player.mo.valid then
		player.glidingmusic = player.mo.paragliding
	end
	
	if player.finallapmusic and finallapmusic then
		if not player.flapjingleflag then
			S_StopMusic(player)
			S_StartSound(nil, sfx_ksflap, player)
			S_SetMusicPosition(0)
			player.flapjingle = 85
			player.flapjingleflag = true
		end
		if player.flapjingle < 0 and not isPowerMusic then
			if player.glidingmusic and glidermusic then
				if tostring(currentmusic) ~= finalglider then
                    COM_BufInsertText(player, "tunes "..finalglider.." 1.0 1.0 "..S_GetMusicPosition())
                end
			else
				if tostring(currentmusic) ~= finallap then
                    COM_BufInsertText(player, "tunes "..finallap.." 1.0 1.0 "..S_GetMusicPosition())
                end
			end
		elseif player.flapjingle == 0 then
            P_RestoreMusic(player)
        end
	else
		if not isPowerMusic then
			if player.glidingmusic and glidermusic then
				if tostring(currentmusic) ~= normalglider then
                    COM_BufInsertText(player, "tunes "..normalglider.." 1.0 1.0 "..S_GetMusicPosition())
                end
			else
				if tostring(currentmusic) ~= normalmusic then
                    COM_BufInsertText(player, "tunes "..normalmusic.." 1.0 1.0 "..S_GetMusicPosition())
                end
			end
		end
	end
	if player.flapjingle > -1 then player.flapjingle = $ - 1 end
end)